package com.dxhy.core.service.frJob;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dxhy.core.dao.frTask.QueryDetailDataDao;
import com.dxhy.core.enmu.FplxEnmu;
import com.dxhy.core.entity.frJob.VoucherRecordQuery;
import com.dxhy.core.entity.frJob.VoucherRecordQueryDetail;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

@Service("queryDetailDataService")
public class QueryDetailDataServiceImpl extends ServiceImpl<QueryDetailDataDao, VoucherRecordQueryDetail>
        implements QueryDetailDataService {

    @Autowired
    private QueryDetailDataDao queryDetailDataDao;

    private static final String JXZZS = "22210101";

    private static final String XXZZS = "22210102";

    private static final String ZYYWSR = "6001";


    @Override
    public void insertJxDataToQueryDetail(){

        String[] time = getTime(JXZZS);
        //2.按照时间查询增量数据
        List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getDataFromRecord(time[0], time[1],JXZZS);
        //3.添加发票类型
        if (dataFromRecordItems != null && dataFromRecordItems.size() != 0){
            dataFromRecordItems.stream().forEach(e->e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
            //4.添加入库

            if (dataFromRecordItems.size()>5000){
                int count = dataFromRecordItems.size()%5000==0?dataFromRecordItems.size()/5000:dataFromRecordItems.size()/5000+1;
                for (int i = 0; i < count; i++) {
                    int start = i*5000;
                    int end = (i+1)*5000;
                    if (i == count-1){
                        end = dataFromRecordItems.size();
                    }
                    List<VoucherRecordQueryDetail> subList = dataFromRecordItems.subList(start,end);
                    queryDetailDataDao.saveOrUpdate(subList);
                }
            }else {
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
            }

        }
    }

    @Override
    public void insertXxDataToQueryDetail(){

        String[] time = getTime(XXZZS);
        //2.按照时间查询增量数据
        List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getDataFromRecordXx(time[0], time[1],XXZZS);
        //3.添加发票类型
        if (dataFromRecordItems != null && dataFromRecordItems.size() != 0){
            dataFromRecordItems.stream().forEach(e->e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
            //4.添加入库

            if (dataFromRecordItems.size()>5000){
                int count = dataFromRecordItems.size()%5000==0?dataFromRecordItems.size()/5000:dataFromRecordItems.size()/5000+1;
                for (int i = 0; i < count; i++) {
                    int start = i*5000;
                    int end = (i+1)*5000;
                    if (i == count-1){
                        end = dataFromRecordItems.size();
                    }
                    List<VoucherRecordQueryDetail> subList = dataFromRecordItems.subList(start,end);
                    queryDetailDataDao.saveOrUpdate(subList);
                }
            }else {
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
            }
        }
    }

    @Override
    public void insertZyDataToQueryDetail(){

        String[] time = getTime(ZYYWSR);
        //2.按照时间查询增量数据
        List<VoucherRecordQueryDetail> dataFromRecordItems = queryDetailDataDao.getDataFromRecordJe(time[0], time[1],ZYYWSR);
        //3添加发票类型
        if (dataFromRecordItems != null && dataFromRecordItems.size() != 0){
            dataFromRecordItems.stream().forEach(e->e.setFplxmc(FplxEnmu.getFplxMap().get(e.getFplx())));
            //4.添加入库
            if (dataFromRecordItems.size()>5000){
                int count = dataFromRecordItems.size()%5000==0?dataFromRecordItems.size()/5000:dataFromRecordItems.size()/5000+1;
                for (int i = 0; i < count; i++) {
                    int start = i*5000;
                    int end = (i+1)*5000;
                    if (i == count-1){
                        end = dataFromRecordItems.size();
                    }
                    List<VoucherRecordQueryDetail> subList = dataFromRecordItems.subList(start,end);
                    queryDetailDataDao.saveOrUpdate(subList);
                }
            }else {
                queryDetailDataDao.saveOrUpdate(dataFromRecordItems);
            }
        }
    }

    @Override
    public String[] getTime(String km){
        //1.获取增量数据开始时间
        Date beginTime = queryDetailDataDao.getBeginTime(km);
        //2.第一次取原表时间
        if (beginTime == null){
            beginTime = queryDetailDataDao.getBeginTimefromRecord();
        }
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        //3.时间转换求结束日期
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(beginTime);
        calendar.add(Calendar.HOUR_OF_DAY,-1);
        //4.开始时间减一天
        String begin = format.format(calendar.getTime());
        //5.结束时间为现在加一天
        calendar.setTime(new Date());
        calendar.add(Calendar.DAY_OF_MONTH,1);
        String end = format.format(calendar.getTime());

        String[] time = {begin,end};
        return time;
    }

    @Override
    public List<String> getRzztDetail() {

        LambdaQueryWrapper<VoucherRecordQueryDetail> querywrapper = new LambdaQueryWrapper<>();
        querywrapper.select(VoucherRecordQueryDetail::getUuid);
        querywrapper.eq(VoucherRecordQueryDetail::getRzzt,"0");

        querywrapper.likeRight(VoucherRecordQueryDetail::getKjkmbh,JXZZS);
        return this.list(querywrapper).stream().map(e -> e.getUuid()).distinct().collect(Collectors.toList());
    }

    @Override
    public void updateRzzt(List<String> uuids) {
        if (uuids!= null && uuids.size() > 0){
            LambdaUpdateWrapper<VoucherRecordQueryDetail> updateWrap = new LambdaUpdateWrapper();
            updateWrap.in(VoucherRecordQueryDetail::getUuid,uuids);
            updateWrap.set(VoucherRecordQueryDetail::getRzzt,"1");
            this.update(updateWrap);
        }
    }
}
